/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.getAssertedObjects;

import java.util.UUID;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.exception.ManyObjectsForFunctionalRelationException;
import org.simantics.db.testing.base.WriteReadTest;
import org.simantics.db.tests.common.Writes;

public class GetAssertedObjectsTest3 extends WriteReadTest {

    private Resource type;
    private Resource string1;
    private Resource string2;
    
	@Override
	protected void write(WriteGraph graph) throws DatabaseException {
		
        // New type with assertions
        type = graph.newResource();
        graph.claim(type, L0.Inherits, L0.Entity);
        
        string1 = Writes.string(graph, UUID.randomUUID().toString());
        string2 = Writes.string(graph, UUID.randomUUID().toString());

        // Assert two functional objects
        graph.claim(type, L0.Asserts, Writes.assertion(graph, L0.HasName, string1));
        graph.claim(type, L0.Asserts, Writes.assertion(graph, L0.HasName, string2));
        
	}
	
	@Override
	protected void read(ReadGraph graph) throws DatabaseException {
		
        try {
        	assertNotNull("Null not allowed", graph.getAssertedObjects(type, L0.HasName));
        } catch (ManyObjectsForFunctionalRelationException e) {
            return;
        }
        
        fail("Should throw.");
        
	}
	
}
