/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.getStatements;

import java.util.Collection;

import org.simantics.db.ReadGraph;
import org.simantics.db.Statement;
import org.simantics.db.WriteGraph;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.testing.base.WriteReadTest;
import org.simantics.db.tests.api.readGraph.common.Ontologies;

public class GetStatementsTest5 extends WriteReadTest {

   

	@Override
	protected void write(WriteGraph graph) throws DatabaseException {
		written = Ontologies.typeMultipleInheritanceConsistsOf(L0, graph);
	}
	
	@Override
	protected void read(ReadGraph graph) throws DatabaseException {
		
        Collection<Statement> results = graph.getStatements(written, L0.ConsistsOf);
        /*
        assertTrue(Tests.contains(results, L0.ConsistsOf, named1));
        assertTrue(Tests.contains(results, L0.ConsistsOf, named2));
        assertTrue(Tests.contains(results, L0.ConsistsOf, named3));
        assertTrue(Tests.contains(results, L0.ConsistsOf, named4));
        assertTrue(Tests.contains(results, L0.ConsistsOf, named5));
        assertTrue(Tests.contains(results, L0.ConsistsOf, named6));
        */
        if (DEBUG)
            System.out.println("results " + results.size());
        assertTrue("Wrong number of results", results.size() == 2);
        
	}

}
