/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.getValue;

import org.simantics.databoard.Bindings;
import org.simantics.db.WriteGraph;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.exception.DoesNotContainValueException;
import org.simantics.db.testing.base.WriteReadTest;

public class GetValueTest22 extends WriteReadTest {

	@Override
	protected void write(WriteGraph graph) throws DatabaseException {
		assertTrue(graph.<Boolean> getValue(L0.True, Bindings.BOOLEAN));
		try {
	        assertNotNull("Null response not allowed", graph.getValue(L0.Entity, Bindings.BOOLEAN));
		} catch (DoesNotContainValueException e) {
			return;
		}
		fail("Should throw.");
	}

}