/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.request.external;

import java.util.concurrent.Semaphore;

import org.junit.Test;
import org.simantics.db.ReadGraph;
import org.simantics.db.Session;
import org.simantics.db.procedure.Listener;
import org.simantics.db.request.ExternalRead;
import org.simantics.db.testing.annotation.Fails;
import org.simantics.db.testing.base.ExistingDatabaseTest;

public class ExternalRequestTest2 extends ExistingDatabaseTest {
	
    int COUNT = 50;
    
	private Error exception;
	
	int counter = 0;
	
	@Test
	@Fails
	public void test() throws Exception {
		
		Session session = getSession();
		
		final Semaphore s = new Semaphore(1-COUNT);
		
		session.syncRequest(new ExternalRead<String>() {

            @Override
            public void register(ReadGraph graph, final Listener<String> procedure) {

                for(int i=0;i<COUNT;i++) {
                	System.err.println("execute: " + "String" + counter);
                	procedure.execute("String" + counter);
                	counter++;
                }
                
            }

            @Override
            public void unregistered() {
            	System.err.println("unregistered");
            }
			
		}, new Listener<String>() {

            @Override
            public void exception(Throwable t) {
            }

            @Override
            public void execute(String result) {
            	new Exception("execute2 " + result).printStackTrace();
                s.release();
            }

            @Override
            public boolean isDisposed() {
                return false;
            }
		    
		});
		
		s.acquire();
		
		if(exception != null) {
			fail("Write transaction threw and exception (" + exception.getMessage() + ") which was not passed through ");
		}
		
	}

}
