package org.simantics.db.tests.api.support;

import org.junit.BeforeClass;
import org.junit.runner.RunWith;
import org.junit.runners.Suite.SuiteClasses;
import org.simantics.db.common.utils.Logger;
import org.simantics.db.testing.common.RegressionSuiteRunner;
import org.simantics.db.testing.common.Tests;
import org.simantics.db.tests.api.support.clusterBuilder.WriteOrderTest;
import org.simantics.db.tests.api.support.clusterControl.CachedDirectPredicatesWithNoCluster;
import org.simantics.db.tests.api.support.clusterControl.ClaimIntoNewResourceAfterIntermediateClusterCollect;
import org.simantics.db.tests.api.support.clusterControl.ClaimIntoNewResourceAfterIntermediateClusterCollect2;
import org.simantics.db.tests.api.support.clusterControl.CreateAndCollectBigClusterInUpdateTest;
import org.simantics.db.tests.api.support.clusterControl.DenyCollectedResourceTest;
import org.simantics.db.tests.api.support.clusterControl.DenyCollectedResourceTest2;
import org.simantics.db.tests.api.support.clusterControl.DenyCollectedResourceTest3;
import org.simantics.db.tests.api.support.clusterControl.DenyCollectedResourceTest4;
import org.simantics.db.tests.api.support.clusterControl.ObjectsWithNoClusterWithCachedRelationInfo;
import org.simantics.db.tests.api.support.clusterControl.QueryCollectedResourceTest;
import org.simantics.db.tests.api.support.clusterControl.WriteAfterClusterCollectTest;
import org.simantics.db.tests.api.support.clusterControl.WriteAfterClusterCollectTest2;
import org.simantics.db.tests.api.support.clusterControl.WriteAfterClusterCollectTest3;
import org.simantics.db.tests.api.support.clusterControl.WriteIntoCollectedResourceTest;
import org.simantics.db.tests.api.support.clusterControl.WriteIntoCollectedResourceTest2;
import org.simantics.db.tests.api.support.clusterControl.WriteIntoCollectedResourceTest3;
import org.simantics.db.tests.api.support.clusterControl.WriteIntoCollectedResourceTest4;
import org.simantics.db.tests.api.support.clusterControl.WriteNewResourceIntoCollectedCluster;
import org.simantics.db.tests.api.support.managementSupport.FetchChangeSetsTest;
import org.simantics.db.tests.api.support.managementSupport.GetHeadRevisionTest;
import org.simantics.db.tests.api.support.managementSupport.GetMetadataTest;
import org.simantics.db.tests.api.support.queryControl.CleanCollectQueriesTest;
import org.simantics.db.tests.api.support.serialisationSupport.RandomAccessIdTest;
import org.simantics.db.tests.api.support.serialisationSupport.RandomAccessIdTest1;
import org.simantics.db.tests.api.support.transferableGraphSupport.TransferableGraphSupportTest1;
import org.simantics.db.tests.api.support.transferableGraphSupport.TransferableGraphSupportTest2;
import org.simantics.db.tests.api.support.undoRedoSupport.RedoTest1;
import org.simantics.db.tests.api.support.undoRedoSupport.RedoTest2;
import org.simantics.db.tests.api.support.undoRedoSupport.UndoTest01;
import org.simantics.db.tests.api.support.undoRedoSupport.UndoTest02;
import org.simantics.db.tests.api.support.undoRedoSupport.UndoTest03;
import org.simantics.db.tests.api.support.undoRedoSupport.UndoTest04;
import org.simantics.db.tests.api.support.undoRedoSupport.UndoTest05;
import org.simantics.db.tests.api.support.undoRedoSupport.UndoTest06;
import org.simantics.db.tests.api.support.undoRedoSupport.UndoTest07;
import org.simantics.db.tests.api.support.undoRedoSupport.UndoTest08;
import org.simantics.db.tests.api.support.undoRedoSupport.UndoTest09;
import org.simantics.db.tests.api.support.undoRedoSupport.UndoTest10;
import org.simantics.db.tests.api.support.undoRedoSupport.UndoTest11;
import org.simantics.db.tests.api.support.undoRedoSupport.UndoTest12;
import org.simantics.db.tests.api.support.undoRedoSupport.UndoTest13;
import org.simantics.db.tests.api.support.undoRedoSupport.UndoTest14;
import org.simantics.db.tests.api.support.undoRedoSupport.UndoTest15;
import org.simantics.db.tests.api.support.undoRedoSupport.UndoTest16;
import org.simantics.db.tests.api.support.undoRedoSupport.UndoTest17;
import org.simantics.db.tests.api.support.undoRedoSupport.UndoTest18;
import org.simantics.db.tests.api.support.undoRedoSupport.UndoTest20;
import org.simantics.db.tests.api.support.virtualGraphSupport.PersistentSetValueIntoVirtualResourceTest;
import org.simantics.db.tests.api.support.virtualGraphSupport.VirtualGraphSupportListStatementsTest;
import org.simantics.db.tests.api.support.virtualGraphSupport.VirtualGraphTest;
import org.simantics.db.tests.api.support.virtualGraphSupport.VirtualGraphTest2;
import org.simantics.db.tests.api.support.virtualGraphSupport.VirtualGraphTest3;
import org.simantics.db.tests.api.support.virtualGraphSupport.VirtualGraphTest5;
import org.simantics.db.tests.api.support.virtualGraphSupport.VirtualGraphTest6;

@RunWith(RegressionSuiteRunner.class)
@SuiteClasses({
	// clusterBuilder
    WriteOrderTest.class,
	// clusterControl
    CachedDirectPredicatesWithNoCluster.class,
    ClaimIntoNewResourceAfterIntermediateClusterCollect.class,
    ClaimIntoNewResourceAfterIntermediateClusterCollect2.class,
    CreateAndCollectBigClusterInUpdateTest.class,
    DenyCollectedResourceTest.class,
    DenyCollectedResourceTest2.class,
    DenyCollectedResourceTest3.class,
    DenyCollectedResourceTest4.class,
    ObjectsWithNoClusterWithCachedRelationInfo.class,
    QueryCollectedResourceTest.class,
    WriteAfterClusterCollectTest.class,
    WriteAfterClusterCollectTest2.class,
    WriteAfterClusterCollectTest3.class,
    WriteIntoCollectedResourceTest.class,
    WriteIntoCollectedResourceTest2.class,
    WriteIntoCollectedResourceTest3.class,
    WriteIntoCollectedResourceTest4.class,
    WriteNewResourceIntoCollectedCluster.class,
    // managementSupport
    GetHeadRevisionTest.class,
    FetchChangeSetsTest.class,
    GetMetadataTest.class,
    // queryControl
    CleanCollectQueriesTest.class,
    // serialisationSupport
    RandomAccessIdTest.class,
    RandomAccessIdTest1.class,
    // transferableGraphSupport
    TransferableGraphSupportTest1.class,
    TransferableGraphSupportTest2.class,
    // undoRedoSupport
    RedoTest1.class,
    RedoTest2.class,
    UndoTest01.class,
    UndoTest02.class,
    UndoTest03.class,
    UndoTest04.class,
    UndoTest05.class,
    UndoTest06.class,
    UndoTest07.class,
    UndoTest08.class,
    UndoTest09.class,
    UndoTest10.class,
    UndoTest11.class,
    UndoTest12.class,
    UndoTest13.class,
    UndoTest14.class,
    UndoTest15.class,
    UndoTest16.class,
    UndoTest17.class,
    UndoTest18.class,
    UndoTest20.class,
    // virtualGraphSupport
    PersistentSetValueIntoVirtualResourceTest.class,
    VirtualGraphSupportListStatementsTest.class,
    VirtualGraphTest.class,
    VirtualGraphTest2.class,
    VirtualGraphTest3.class,
    VirtualGraphTest5.class,
    VirtualGraphTest6.class
})
public class SuiteSupport {

	@BeforeClass
    public static void setUp() {
		try {
			Tests.freshDatabase();
		} catch (Exception e) {
			Logger.defaultLogError(e);
		}
    }
	
}
