/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.client;


import org.junit.Test;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.testing.base.TestCommonNoVirtual;
import org.simantics.db.testing.common.Client;
import org.simantics.db.testing.common.ClientFactory;
import org.simantics.db.tests.common.ClientOperations;
import org.simantics.db.tests.common.Configuration;

public class RefreshTest1 extends TestCommonNoVirtual {
    private static final int COUNT = Configuration.get().refreshLoopCount;
    
    @Test
    public void testRefresh1() throws DatabaseException {
        if (noVirtual())
            return;
        for (int i=0; i<COUNT; ++i) {
            refreshTestAdd();
        }
    }
    void refreshTestAdd() throws DatabaseException {
//        ServerAddress serverAddress = getSessionContext().getAddress();
        Client client1 = ClientFactory.create(getRandomString());
        Client client2 = ClientFactory.create(getRandomString());
        try {
            String name = ClientOperations.createData(client1);
            ClientOperations.validateData(client1, name);
            ClientOperations.validateData(client2, name);
            name = ClientOperations.createData(client2);
            ClientOperations.validateData(client2, name);
            ClientOperations.validateData(client1, name);
            name = ClientOperations.createData(client2);
            ClientOperations.validateData(client2, name);
            String name2 = ClientOperations.createData(client1);
            ClientOperations.validateData(client1, name);
            ClientOperations.validateData(client1, name2);
            ClientOperations.validateData(client2, name2);
        } finally {
            if (null != client1)
                client1.close();
            if (null != client2)
                client2.close();
        }
    }
}